=== debian/changelog ===
teensy-loader-cli (2.1-1) unstable; urgency=medium

  * Initial release (Closes: #885176)

 -- Michael Stapelberg <stapelberg@debian.org>  Mon, 25 Dec 2017 19:03:56 +0100
