=== debian/control ===
Source: teensy-loader-cli
Section: devel
Priority: optional
Maintainer: Michael Stapelberg <stapelberg@debian.org>
Build-Depends: debhelper (>= 10), libusb-dev
Standards-Version: 4.1.1
Homepage: https://www.pjrc.com/teensy/loader_cli.html
Vcs-Git: https://anonscm.debian.org/collab-maint/teensy-loader-cli.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/teensy-loader-cli.git

Package: teensy-loader-cli
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: load and run programs onto your Teensy micro controller
 See https://www.pjrc.com/teensy/ for an introduction to the Teensy family of
 USB-based microcontroller development systems.
 .
 The teensy loader cli is a command-line alternative to the graphical teensy
 loader which is included with Teensyduino. The cli version is preferred by
 advanced users who want to automate programming, typically from within a
 Makefile or similar.
