## teensy-loader-cli 2.2

=== Makefile ===
--- 
+++ 
@@ -12,11 +12,11 @@
 CC ?= gcc
 CFLAGS ?= -O2 -Wall
 teensy_loader_cli: teensy_loader_cli.c
-	$(CC) $(CFLAGS) -s -DUSE_LIBUSB -o teensy_loader_cli teensy_loader_cli.c -lusb
+	$(CC) $(CFLAGS) $(CPPFLAGS) -s -DUSE_LIBUSB -o teensy_loader_cli teensy_loader_cli.c -lusb $(LDFLAGS)
 
 
 else ifeq ($(OS), WINDOWS)
-CC = i586-mingw32msvc-gcc
+CC ?= i586-mingw32msvc-gcc
 CFLAGS ?= -O2 -Wall
 teensy_loader_cli.exe: teensy_loader_cli.c
 	$(CC) $(CFLAGS) -s -DUSE_WIN32 -o teensy_loader_cli.exe teensy_loader_cli.c -lhid -lsetupapi -lwinmm
@@ -33,8 +33,14 @@
 CC ?= gcc
 SDK ?= $(shell xcrun --show-sdk-path)
 #SDK ?= /Developer/SDKs/MacOSX10.6.sdk  # the old way...
+#SDK = /Developer_xcode32/SDKs/MacOSX10.5.sdk  # the very old way!
+#CC = /Developer_xcode32/usr/bin/gcc-4.0
+#CFLAGS = -O2 -Wall -arch i386 -arch ppc
 CFLAGS ?= -O2 -Wall
 teensy_loader_cli: teensy_loader_cli.c
+ifeq ($(SDK),)
+	$(error SDK was not found. To use this type of compilation please install Xcode)
+endif
 	$(CC) $(CFLAGS) -DUSE_APPLE_IOKIT -isysroot $(SDK) -o teensy_loader_cli teensy_loader_cli.c -Wl,-syslibroot,$(SDK) -framework IOKit -framework CoreFoundation
 
 endif
@@ -50,4 +56,4 @@
 
 
 clean:
-	rm -f teensy_loader_cli teensy_loader_cli.exe
+	rm -f teensy_loader_cli teensy_loader_cli.exe*
