=== debian/changelog ===
teensy-loader-cli (2.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Let dh_installudev install udev rules. (Closes: #1058859)

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 30 May 2024 02:13:46 +0200

teensy-loader-cli (2.2-1) unstable; urgency=medium

  * New upstream release, contained all debian patches
  * New maintainer (Closes: #930306)
  * VCS is at Salsa
  * Added a  `debian/.gitignore` file
  * Added 'Rules-Requires-Root: no' to d/control
  * Removed d/lintian-overrides on Upstream not providing a changelog file.
  * Standards version to 4.6.0 (Released August 2021)
  * Suppress Lintian warning about the udev rules file

 -- Geert Stappers <stappers@debian.org>  Sat, 15 Jan 2022 21:59:54 +0100
