=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: teensy-loader-cli
 Section: devel
 Priority: optional
-Maintainer: Michael Stapelberg <stapelberg@debian.org>
+Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
+Uploaders: Geert Stappers <stappers@debian.org>
 Build-Depends: debhelper (>= 10), libusb-dev
-Standards-Version: 4.1.1
+Rules-Requires-Root: no
+Standards-Version: 4.6.0
 Homepage: https://www.pjrc.com/teensy/loader_cli.html
-Vcs-Git: https://anonscm.debian.org/collab-maint/teensy-loader-cli.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/teensy-loader-cli.git
+Vcs-Browser: https://salsa.debian.org/electronics-team/teensy-loader-cli
+Vcs-Git: https://salsa.debian.org/electronics-team/teensy-loader-cli.git
 
 Package: teensy-loader-cli
 Architecture: any
