=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_installudev:
	dh_installudev --priority=49 --name=teensy
